Gecode::Int::ReMixBinaryPropagator< View0, pc0, View1, pc1, CtrlView > Class Template Reference

Reified mixed binary propagator. More...

`#include <propagator.hpp>`

## Public Member Functions

virtual PropCost | cost (const Space &home, const ModEventDelta &med) const
| Cost function (defined as low binary).
virtual void | reschedule (Space &home)
| Schedule function.
virtual size_t | dispose (Space &home)
| Delete propagator and return its size.
virtual ExecStatus | propagate (Space &home, const ModEventDelta &med)=0
| Propagation function.
ModEventDelta | modeventdelta (void) const
| Return the modification event delta.
virtual ExecStatus | advise (Space &home, Advisor &a, const Delta &d)
| Advise function.
virtual void | advise (Space &home, Advisor &a)
| Run advisor a to be run on failure in failed space.
double | afc (void) const
| Return the accumlated failure count.
unsigned int | id (void) const
| Return propagator id.
PropagatorGroup | group (void) const
| Return group propagator belongs to.
void | group (PropagatorGroup g)
| Add propagator to group g.
bool | disabled (void) const
| Whether propagator is currently disabled.
Public Member Functions inherited from Gecode::Actor
virtual Actor * | copy (Space &home)=0
| Create copy.
virtual | ~Actor (void)
| To avoid warnings.

## Protected Member Functions

| ReMixBinaryPropagator (Space &home, ReMixBinaryPropagator &p)
| Constructor for cloning p.
| ReMixBinaryPropagator (Home home, View0 x0, View1 x1, CtrlView b)
| Constructor for creation.
| ReMixBinaryPropagator (Space &home, Propagator &p, View0 x0, View1 x1, CtrlView b)
| Constructor for rewriting p during cloning.
Protected Member Functions inherited from Gecode::Propagator
| Propagator (Home home)
| Constructor for posting.
| Propagator (Space &home, Propagator &p)
| Constructor for cloning p.
Propagator * | fwd (void) const
| Return forwarding pointer during copying.
Kernel::GPI::Info & | gpi (void)
| Provide access to global propagator information.

## Protected Attributes

View0 | x0
| View of type View0.
View1 | x1
| View of type View1.
CtrlView | b
| Boolean control view.

## Additional Inherited Members

static void * | operator new (size_t s, Space &home)
| Allocate memory from space.
static void | operator delete (void *p, Space &home)
| No-op for exceptions.
static void * | operator new (size_t s)
| Not used.
static void | operator delete (void *p)
| Not used.

## Detailed Description

template<class View0, PropCond pc0, class View1, PropCond pc1, class CtrlView>
class Gecode::Int::ReMixBinaryPropagator< View0, pc0, View1, pc1, CtrlView >

Reified mixed binary propagator.

Stores two views of type View0 and View1 with propagation conditions pc0 and pc1 and a Boolean control view of type CtrlView.

If the propagation conditions pc0 or pc1 have the values PC_GEN_NONE, no subscriptions are created.

Definition at line 124 of file propagator.hpp.

## Constructor & Destructor Documentation

## ReMixBinaryPropagator() [1/3]

template<class View0, PropCond pc0, class View1, PropCond pc1, class CtrlView>

Gecode::Int::ReMixBinaryPropagator< View0, pc0, View1, pc1, CtrlView >::ReMixBinaryPropagator | ( | Space & | home,
|  | ReMixBinaryPropagator< View0, pc0, View1, pc1, CtrlView > & | p )

inline protected

Constructor for cloning p.

Definition at line 286 of file propagator.hpp.

## ReMixBinaryPropagator() [2/3]

template<class View0, PropCond pc0, class View1, PropCond pc1, class CtrlView>

Gecode::Int::ReMixBinaryPropagator< View0, pc0, View1, pc1, CtrlView >::ReMixBinaryPropagator | ( | Home | home,
|  | View0 | x0,
|  | View1 | x1,
|  | CtrlView | b )

protected

Constructor for creation.

Definition at line 274 of file propagator.hpp.

## ReMixBinaryPropagator() [3/3]

template<class View0, PropCond pc0, class View1, PropCond pc1, class CtrlView>

Gecode::Int::ReMixBinaryPropagator< View0, pc0, View1, pc1, CtrlView >::ReMixBinaryPropagator | ( | Space & | home,
|  | Propagator & | p,
|  | View0 | x0,
|  | View1 | x1,
|  | CtrlView | b )

inline protected

Constructor for rewriting p during cloning.

Definition at line 299 of file propagator.hpp.

## Member Function Documentation

## cost()

template<class View0, PropCond pc0, class View1, PropCond pc1, class CtrlView>

PropCost Gecode::Int::ReMixBinaryPropagator< View0, pc0, View1, pc1, CtrlView >::cost | ( | const Space & | home,
|  | const ModEventDelta & | med ) const

virtual

Cost function (defined as low binary).

Implements Gecode::Propagator.

Definition at line 311 of file propagator.hpp.

## reschedule()

template<class View0, PropCond pc0, class View1, PropCond pc1, class CtrlView>

void Gecode::Int::ReMixBinaryPropagator< View0, pc0, View1, pc1, CtrlView >::reschedule | ( | Space & | home | ) |

virtual

Schedule function.

Implements Gecode::Propagator.

Definition at line 318 of file propagator.hpp.

## dispose()

template<class View0, PropCond pc0, class View1, PropCond pc1, class CtrlView>

size_t Gecode::Int::ReMixBinaryPropagator< View0, pc0, View1, pc1, CtrlView >::dispose | ( | Space & | home | ) |

inline virtual

Delete propagator and return its size.

Reimplemented from Gecode::Actor.

Definition at line 329 of file propagator.hpp.

## Member Data Documentation

## x0

template<class View0, PropCond pc0, class View1, PropCond pc1, class CtrlView>

View0 Gecode::Int::ReMixBinaryPropagator< View0, pc0, View1, pc1, CtrlView >::x0

protected

View of type View0.

Definition at line 127 of file propagator.hpp.

## x1

template<class View0, PropCond pc0, class View1, PropCond pc1, class CtrlView>

View1 Gecode::Int::ReMixBinaryPropagator< View0, pc0, View1, pc1, CtrlView >::x1

protected

View of type View1.

Definition at line 129 of file propagator.hpp.

## b

template<class View0, PropCond pc0, class View1, PropCond pc1, class CtrlView>

CtrlView Gecode::Int::ReMixBinaryPropagator< View0, pc0, View1, pc1, CtrlView >::b

protected

Boolean control view.

Definition at line 131 of file propagator.hpp.

The documentation for this class was generated from the following file:

- gecode/int/propagator.hpp